Index: /trunk/doc/manual/en_US/dita/topics/Introduction.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/Introduction.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/Introduction.dita	(revision 105619)
@@ -6,13 +6,10 @@
   <body>
     <p>Welcome to <ph conkeyref="vbox-conkeyref-phrases/product-name"/>.</p>
-    <p><ph conkeyref="vbox-conkeyref-phrases/product-name"/> is a cross-platform virtualization
-      application. What does that mean? For one thing, it installs on your existing Intel or
-      AMD-based computers, whether they are running Windows, macOS, Linux, or Oracle Solaris
-      operating systems (OSes). Second, it extends the capabilities of your existing computer so
-      that it can run multiple OSes, inside multiple virtual machines, at the same time. As an
-      example, you can run Windows and Linux on your Mac, run Windows Server on your Linux server,
-      run Linux on your Windows PC, and so on, all alongside your existing applications. You can
-      install and run as many virtual machines as you like. The only practical limits are disk space
-      and memory.</p>
+    <p><ph conkeyref="vbox-conkeyref-phrases/product-name"/> is a cross-platform virtualization application. That means
+      it extends the capabilities of your existing computer so that it can run multiple operating systems, inside
+      multiple virtual machines (VMs), at the same time. As an example, you can run Windows and Linux on your Mac, run
+      Windows Server on your Linux server, run Linux on your Windows PC, and so on, all alongside your existing
+      applications. You can install and run as many virtual machines as you like. The only practical limits are disk
+      space and memory.</p>
     <p><ph conkeyref="vbox-conkeyref-phrases/product-name"/> is deceptively simple yet also very powerful. It can run
       everywhere from small embedded systems or desktop class machines all the way up to data center deployments and
Index: /trunk/doc/manual/en_US/dita/topics/KnownProblems.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/KnownProblems.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/KnownProblems.dita	(revision 105619)
@@ -5,40 +5,24 @@
   
   <body>
-    <p>
-      The following section describes known problems with this release
-      of <ph conkeyref="vbox-conkeyref-phrases/product-name"/>. Unless marked otherwise, these issues are
-      planned to be fixed in later releases.
-    </p>
+    <p>The following section describes known problems with this release of <ph
+        conkeyref="vbox-conkeyref-phrases/product-name"/>. Unless marked otherwise, these issues are planned to be fixed
+      in later releases. </p>
     <ul>
       <li>
-        <p>
-          The macOS installer packages for <ph conkeyref="vbox-conkeyref-phrases/product-name"/> 7 currently do
-          not include the Internal Networking feature, which is
-          available on all other platforms. This will be addressed with
-          an update of <ph conkeyref="vbox-conkeyref-phrases/product-name"/> 7. For setups which depend on this
-          functionality it is best to keep using <ph conkeyref="vbox-conkeyref-phrases/product-name"/> 6.1.
-        </p>
-      </li>
-      <li>
-        <p>
-          Poor performance when using <ph conkeyref="vbox-conkeyref-phrases/product-name"/> and
-          <b outputclass="bold">Hyper-V</b> on the same host. To
-          fix this, certain Windows features like "Hyper-V Platform",
-          "Virtual Machine Platform" and "Windows Hypervisor Platform"
-          must be turned off, followed by a host reboot.
-        </p>
-        <p>
-          Additionally, the Microsoft Device Guard and Credential Guard
-          hardware readiness tool might have to be used in order to turn
-          off more features. For example, by running the following
-          command:
-        </p>
+        <p>The macOS installer packages for <ph conkeyref="vbox-conkeyref-phrases/product-name"/> 7 currently do not
+          include the Internal Networking feature, which is available on all other platforms. This will be addressed
+          with an update of <ph conkeyref="vbox-conkeyref-phrases/product-name"/> 7. For setups which depend on this
+          functionality it is best to keep using <ph conkeyref="vbox-conkeyref-phrases/product-name"/> 6.1. </p>
+      </li>
+      <li>
+        <p>Poor performance when using <ph conkeyref="vbox-conkeyref-phrases/product-name"/> and <b outputclass="bold"
+            >Hyper-V</b> on the same host. To fix this, certain Windows features like "Hyper-V Platform", "Virtual
+          Machine Platform" and "Windows Hypervisor Platform" must be turned off, followed by a host reboot. </p>
+        <p>Additionally, the Microsoft Device Guard and Credential Guard hardware readiness tool might have to be used
+          in order to turn off more features. For example, by running the following command: </p>
         <pre xml:space="preserve">.\DG_Readiness_Tool_vX.X.ps1 -Disable -AutoReboot</pre>
         <note>
-          <p>
-            Disabling Device Guard and Credential Guard features will
-            have an impact on the overall security of the host. Please
-            contact your Administrator beforehand regarding this.
-          </p>
+          <p>Disabling Device Guard and Credential Guard features will have an impact on the overall security of the
+            host. Please contact your Administrator beforehand regarding this. </p>
         </note>
       </li>
@@ -83,14 +67,9 @@
           running is currently logged in and has a desktop session.
         </p>
-        <p>
-          Also, to use accounts without or with an empty password, the
-          guest's group policy must be changed. To do so, open the group
-          policy editor on the command line by typing
-          <userinput>gpedit.msc</userinput>, open the key <codeph>Computer
-          Configuration\Windows Settings\Security Settings\Local
-          Policies\Security Options</codeph> and change the value of
-          <codeph>Accounts: Limit local account use of blank passwords
-          to console logon only</codeph> to Disabled.
-        </p>
+        <p>Also, to use accounts without or with an empty password, the guest's group policy must be changed. To do so,
+          open the group policy editor on the command line by typing <userinput>gpedit.msc</userinput>, open the key
+            <codeph>Computer Configuration\Windows Settings\Security Settings\Local Policies\Security Options</codeph>
+          and change the value of <codeph>Accounts: Limit local account use of blank passwords to console logon
+            only</codeph> to Disabled. </p>
       </li>
       <li>
@@ -105,62 +84,36 @@
       </li>
       <li>
-        <p>
-          <b outputclass="bold">OVF import/export:</b>
-        </p>
-        <ul>
-          <li>
-            <p>
-              OVF localization, with multiple languages in a single OVF
-              file, is not yet supported.
-            </p>
-          </li>
-          <li>
-            <p>
-              Some OVF sections like StartupSection,
-              DeploymentOptionSection, and InstallSection are ignored.
-            </p>
-          </li>
-          <li>
-            <p>
-              OVF environment documents, including their property
-              sections and appliance configuration with ISO images, are
-              not yet supported.
-            </p>
-          </li>
-          <li>
-            <p>
-              Remote files using HTTP or other mechanisms are not yet
-              supported.
-            </p>
-          </li>
-        </ul>
-      </li>
-      <li>
-        <p>
-          Neither <b outputclass="bold">scale mode</b> nor
-          <b outputclass="bold">seamless mode</b> work correctly
-          with guests using OpenGL 3D features, such as with
-          Compiz-enabled window managers.
-        </p>
-      </li>
-      <li>
-        <p>
-          The RDP server in the <ph conkeyref="vbox-conkeyref-phrases/product-name"/> extension pack supports
-          only audio streams in format 22.05kHz stereo 16-bit. If the
-          RDP client requests any other audio format there will be no
-          audio.
-        </p>
-      </li>
-      <li>
-        <p>
-          Preserving the aspect ratio in scale mode works only on
-          Windows hosts and on macOS hosts.
-        </p>
-      </li>
-      <li>
-        <p>
-          On <b outputclass="bold">macOS hosts</b>, the following
-          features are not yet implemented:
-        </p>
+        <p><b outputclass="bold">OVF import/export:</b>
+        </p>
+        <ul>
+          <li>
+            <p>OVF localization, with multiple languages in a single OVF file, is not yet supported. </p>
+          </li>
+          <li>
+            <p>Some OVF sections like StartupSection, DeploymentOptionSection, and InstallSection are ignored. </p>
+          </li>
+          <li>
+            <p>OVF environment documents, including their property sections and appliance configuration with ISO images,
+              are not yet supported. </p>
+          </li>
+          <li>
+            <p>Remote files using HTTP or other mechanisms are not yet supported. </p>
+          </li>
+        </ul>
+      </li>
+      <li>
+        <p>Neither <b outputclass="bold">scale mode</b> nor <b outputclass="bold">seamless mode</b> work correctly with
+          guests using OpenGL 3D features, such as with Compiz-enabled window managers. </p>
+      </li>
+      <li>
+        <p>The RDP server in the <ph conkeyref="vbox-conkeyref-phrases/product-name"/> extension pack supports only
+          audio streams in format 22.05kHz stereo 16-bit. If the RDP client requests any other audio format there will
+          be no audio. </p>
+      </li>
+      <li>
+        <p>Preserving the aspect ratio in scale mode works only on Windows hosts and on macOS hosts. </p>
+      </li>
+      <li>
+        <p>On <b outputclass="bold">macOS hosts</b>, the following features are not yet implemented: </p>
         <ul>
           <li>
@@ -182,58 +135,49 @@
       </li>
       <li>
-        <p>
-          <b outputclass="bold">macOS/Arm64 (Apple silicon) host package</b>
-        </p>
-      </li>
-      <li>
-        <p>
-          <b outputclass="bold">Mac OS X guests:</b>
-        </p>
-        <ul>
-          <li>
-            <p>
-              Mac OS X guests can only run on a certain host hardware.
-              For details about license and host hardware limitations.
-              See <xref href="intro-macosxguests.dita">Mac OS X Guests</xref> and check the
-              Apple software license conditions.
-            </p>
-          </li>
-          <li>
-            <p>
-              <ph conkeyref="vbox-conkeyref-phrases/product-name"/> does not provide Guest Additions for Mac OS
-              X at this time.
-            </p>
-          </li>
-          <li>
-            <p>
-              The graphics resolution currently defaults to 1024x768 as
-              Mac OS X falls back to the built-in EFI display support.
-              See <xref href="efividmode.dita">Video Modes in EFI</xref> for more information on
-              how to change EFI video modes.
-            </p>
-          </li>
-          <li>
-            <p>
-              Mac OS X guests only work with one CPU assigned to the VM.
-              Support for SMP will be provided in a future release.
-            </p>
-          </li>
-          <li>
-            <p>
-              Depending on your system and version of Mac OS X, you
-              might experience guest hangs after some time. This can be
-              fixed by turning off energy saving. Set the timeout to
-              "Never" in the system preferences.
-            </p>
-          </li>
-          <li>
-            <p>
-              By default, the <ph conkeyref="vbox-conkeyref-phrases/product-name"/> EFI enables debug output of
-              the Mac OS X kernel to help you diagnose boot problems.
-              Note that there is a lot of output and not all errors are
-              fatal. They would also show when using a physical Apple
-              Macintosh computer. You can turn off these messages by
-              using the following command:
-            </p>
+        <p><b outputclass="bold">macOS/Arm 64 (Apple silicon) host package</b>
+          <ul id="ul_ddr_kzn_hcc">
+            <li>
+              <p>x86-based guest operating systems will not run</p>
+      </li>
+      <li>
+              <p>Arm(AArch64) guests only. Arm 32 is not supported at present.</p>
+            </li>
+            <li>
+              <p>Arm hosts have limitations with sound, storage, graphics, guest additions and unattended
+                installation.</p>
+            </li>
+          </ul></p>
+      </li>
+      <li>
+        <p><b outputclass="bold">Mac OS X guests:</b>
+        </p>
+        <ul>
+          <li>
+            <p>Mac OS X guests can only run on a certain host hardware. For details about license and host hardware
+              limitations. See <xref href="intro-macosxguests.dita">Mac OS X Guests</xref> and check the Apple software
+              license conditions. </p>
+          </li>
+          <li>
+            <p><ph conkeyref="vbox-conkeyref-phrases/product-name"/> does not provide Guest Additions for Mac OS X at
+              this time. </p>
+          </li>
+          <li>
+            <p>The graphics resolution currently defaults to 1024x768 as Mac OS X falls back to the built-in EFI display
+              support. See <xref href="efividmode.dita">Video Modes in EFI</xref> for more information on how to change
+              EFI video modes. </p>
+          </li>
+          <li>
+            <p>Mac OS X guests only work with one CPU assigned to the VM. Support for SMP will be provided in a future
+              release. </p>
+          </li>
+          <li>
+            <p>Depending on your system and version of Mac OS X, you might experience guest hangs after some time. This
+              can be fixed by turning off energy saving. Set the timeout to "Never" in the system preferences. </p>
+          </li>
+          <li>
+            <p>By default, the <ph conkeyref="vbox-conkeyref-phrases/product-name"/> EFI enables debug output of the Mac
+              OS X kernel to help you diagnose boot problems. Note that there is a lot of output and not all errors are
+              fatal. They would also show when using a physical Apple Macintosh computer. You can turn off these
+              messages by using the following command: </p>
             <pre xml:space="preserve">$ VBoxManage setextradata <varname>VM-name</varname> "VBoxInternal2/EfiBootArgs" "  "</pre>
             <p>
@@ -244,9 +188,6 @@
           </li>
           <li>
-            <p>
-              It is currently not possible to start a Mac OS X guest in
-              safe mode by specifying the <codeph>-x</codeph> option in
-              <codeph>VBoxInternal2/EfiBootArgs</codeph> extradata.
-            </p>
+            <p>It is currently not possible to start a Mac OS X guest in safe mode by specifying the <codeph>-x</codeph>
+              option in <codeph>VBoxInternal2/EfiBootArgs</codeph> extradata. </p>
           </li>
         </ul>
@@ -258,51 +199,28 @@
         <ul>
           <li>
-            <p>
-              USB support on Oracle Solaris hosts requires Oracle
-              Solaris 11 version snv_124 or later. Webcams and other
-              isochronous devices are known to have poor performance.
-            </p>
-          </li>
-          <li>
-            <p>
-              Host Webcam passthrough is restricted to 640x480 frames at
-              20 frames per second due to limitations in the Oracle
-              Solaris V4L2 API. This may be addressed in a future Oracle
-              Solaris release.
-            </p>
-          </li>
-          <li>
-            <p>
-              No ACPI information, such as battery status or power
-              source, is reported to the guest.
-            </p>
-          </li>
-          <li>
-            <p>
-              No support for using wireless adapters with bridged
-              networking.
-            </p>
-          </li>
-          <li>
-            <p>
-              Crossbow-based bridged networking on Oracle Solaris 11
-              hosts does not work directly with aggregate links.
-              However, you can use <userinput>dladm</userinput> to manually
-              create a VNIC over the aggregate link and use that with a
-              VM. This limitation does not exist in Oracle Solaris 11u1
-              build 17 and later.
-            </p>
-          </li>
-        </ul>
-      </li>
-      <li>
-        <p>
-          Neither virtio nor Intel PRO/1000 drivers for
-          <b outputclass="bold">Windows XP guests</b> support
-          segmentation offloading. Therefore Windows XP guests have
-          slower transmission rates comparing to other guest types.
-          Refer to MS Knowledge base article 842264 for additional
-          information.
-        </p>
+            <p>USB support on Oracle Solaris hosts requires Oracle Solaris 11 version snv_124 or later. Webcams and
+              other isochronous devices are known to have poor performance. </p>
+          </li>
+          <li>
+            <p>Host Webcam passthrough is restricted to 640x480 frames at 20 frames per second due to limitations in the
+              Oracle Solaris V4L2 API. This may be addressed in a future Oracle Solaris release. </p>
+          </li>
+          <li>
+            <p>No ACPI information, such as battery status or power source, is reported to the guest. </p>
+          </li>
+          <li>
+            <p>No support for using wireless adapters with bridged networking. </p>
+          </li>
+          <li>
+            <p>Crossbow-based bridged networking on Oracle Solaris 11 hosts does not work directly with aggregate links.
+              However, you can use <userinput>dladm</userinput> to manually create a VNIC over the aggregate link and
+              use that with a VM. This limitation does not exist in Oracle Solaris 11u1 build 17 and later. </p>
+          </li>
+        </ul>
+      </li>
+      <li>
+        <p>Neither virtio nor Intel PRO/1000 drivers for <b outputclass="bold">Windows XP guests</b> support
+          segmentation offloading. Therefore Windows XP guests have slower transmission rates comparing to other guest
+          types. Refer to MS Knowledge base article 842264 for additional information. </p>
       </li>
       <li>
@@ -314,17 +232,10 @@
       </li>
       <li>
-        <p>
-          Some guest operating systems predating ATAPI CD-ROMs may
-          exhibit long delays or entirely fail to boot in certain
-          configurations. This is most likely to happen when an
-          IDE/ATAPI CD-ROM exists alone on a primary or secondary IDE
-          channel.
-        </p>
-        <p>
-          Affected operating systems are MS OS/2 1.21: fails to boot
-          with an error message referencing COUNTRY.SYS and MS OS/2 1.3:
-          long boot delays. To avoid such problems, disable the emulated
-          IDE/ATAPI CD-ROM. The guest OS cannot use this device, anyway.
-        </p>
+        <p>Some guest operating systems predating ATAPI CD-ROMs may exhibit long delays or entirely fail to boot in
+          certain configurations. This is most likely to happen when an IDE/ATAPI CD-ROM exists alone on a primary or
+          secondary IDE channel. </p>
+        <p>Affected operating systems are MS OS/2 1.21: fails to boot with an error message referencing COUNTRY.SYS and
+          MS OS/2 1.3: long boot delays. To avoid such problems, disable the emulated IDE/ATAPI CD-ROM. The guest OS
+          cannot use this device, anyway. </p>
       </li>
     </ul>
Index: /trunk/doc/manual/en_US/dita/topics/create-vm-wizard-name-os.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/create-vm-wizard-name-os.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/create-vm-wizard-name-os.dita	(revision 105619)
@@ -16,7 +16,8 @@
           snapshots feature. See also <xref href="vboxconfigdata-machine-folder.dita">The Machine
             Folder</xref>.</li>
-        <li>Select the ISO image file for the operating system you intend to install on the new VM.
-          The image file can be used directly to install an OS on the new VM as part of an
-          unattended installation, or it can be attached to a DVD drive on the new VM.</li>
+        <li>Select the ISO image file for the operating system you intend to install on the new VM. The image file can
+          be used directly to install an OS on the new VM as part of an unattended installation, or it can be attached
+          to a DVD drive on the new VM. If the image contains more than one edition, select the edition you want to
+          use.</li>
         <li><ph conkeyref="vbox-conkeyref-phrases/product-name"/> will populate the <b>Type</b>,
             <b>Subtype</b>, and <b>Version</b> fields if it can detect the operating system in the
@@ -30,12 +31,10 @@
               href="intro-64bitguests.dita#intro-64bitguests"/>) but you must always set this field
             to the correct value.</p></li>
-        <li>By default, <ph conkeyref="vbox-conkeyref-phrases/product-name"/> will install the
-          chosen OS using the ISO image provided, if the image supports unattended installation. See
-          also <xref
-            href="create-vm-wizard-unattended-install.dita#create-vm-wizard-unattended-install"
-            />.<p>If you prefer to install the OS, you can disable the unattended guest operating
-            system install feature by selecting <b outputclass="bold">Skip Unattended
-              Installation</b>. In that case, the selected ISO image is mounted automatically on the
-            DVD drive of the new VM and you must install the OS from there.</p><p>Not all images
+        <li>By default, <ph conkeyref="vbox-conkeyref-phrases/product-name"/> will install the chosen OS using the ISO
+          image provided, if the image supports unattended installation. See also <xref
+            href="create-vm-wizard-unattended-install.dita#create-vm-wizard-unattended-install"/>.<p>If you prefer to
+            install the OS manually, you can disable the unattended guest operating system install feature by selecting
+              <b outputclass="bold">Skip Unattended Installation</b>. In that case, the selected ISO image is mounted
+            automatically on the DVD drive of the new VM and you must install the OS from there.</p><p>Not all images
             support unattended installation.</p></li>
         <li>Click Next to <xref
Index: /trunk/doc/manual/en_US/dita/topics/create-vm-wizard-virtual-hard-disk.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/create-vm-wizard-virtual-hard-disk.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/create-vm-wizard-virtual-hard-disk.dita	(revision 105619)
@@ -67,7 +67,7 @@
       <title>Use an Existing Virtual Hard Disk</title>
     </section>
-    <p>Follow these steps to use a virtual hard disk that already exists on the host. Ensure the
-      image file is in a suitable location (usually the machine folder) and not in use by other
-        VMs.<ol id="ol_txk_str_pbc">
+    <p>Follow these steps to use a virtual hard disk that already exists on the host. Ensure the image file is in a
+      suitable location (usually the machine folder) and not in use by other VMs.<note id="note_fzl_3tw_hcc"
+        type="caution">Data on the disk image may be deleted.</note><ol id="ol_txk_str_pbc">
         <li>
           <p>Select <b outputclass="bold">Use an Existing Virtual Hard Disk File</b>
@@ -75,6 +75,5 @@
         </li>
         <li>
-          <p>Select the image file to use with the new VM, and then click <b outputclass="bold"
-              >Add</b>. </p>
+          <p>Select the image file to use with the new VM, and then click <b outputclass="bold">Add</b>. </p>
         </li>
       </ol></p>
Index: /trunk/doc/manual/en_US/dita/topics/create-vm-wizard.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/create-vm-wizard.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/create-vm-wizard.dita	(revision 105619)
@@ -14,4 +14,6 @@
         <li><xref href="create-vm-wizard-virtual-hard-disk.dita"/></li>
       </ul></p>
+    <p>If you don't see the wizard, change the experience level to <b>Basic</b>. See <xref
+        href="ui-experience-level.dita"/>.</p>
     <p>Once created, the virtual machine is displayed in the machine list on the left side of the
         <ph conkeyref="vbox-conkeyref-phrases/vbox-mgr"/> window, with the name that you entered on
@@ -19,7 +21,7 @@
     <p>You can change the settings later, after you have created the VM, using the Machine
       Settings.</p>
-    <p>Before you start you must have an operating system image, in ISO format, for the operating
-      system you intend to install on the VM. <ph conkeyref="vbox-conkeyref-phrases/product-name"/>
-      does not supply the OS or any license required to use it. </p>
+    <p>You must supply an operating system image, in ISO format, for the operating system you intend to install on the
+      VM. <ph conkeyref="vbox-conkeyref-phrases/product-name"/> does not supply the OS or any license required to use
+      it. </p>
     <p><!--7.1: Note added re platforms and paragraph re ISO requirement. Reworded when removing screenshots. Subpages also updated.--></p>
       <note>
Index: /trunk/doc/manual/en_US/dita/topics/guestadd-clipboard-limitations.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/guestadd-clipboard-limitations.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/guestadd-clipboard-limitations.dita	(revision 105619)
@@ -5,11 +5,7 @@
   
   <body>
-    <p>
-        The following limitations are known for Shared Clipboard file transfers:
-      </p>
-    <p>
-        On Linux hosts and guests, Shared Clipboard file transfers are currently limited to files only,
-        one file per transfer. Transferring symbolic links are also not supported.
-      </p>
+    <p>The following limitations are known for Shared Clipboard file transfers: </p>
+    <p>On Linux hosts and guests, Shared Clipboard file transfers are currently limited to files only, one file per
+      transfer. Transferring symbolic links is not supported. </p>
   </body>
 
Index: /trunk/doc/manual/en_US/dita/topics/guestadd-clipboard.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/guestadd-clipboard.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/guestadd-clipboard.dita	(revision 105619)
@@ -9,4 +9,26 @@
       guest, and vice versa. For this to work the latest version of the Guest Additions must be installed on the
       guest.</p>    
+    <p>For security reasons drag and drop can be configured at runtime on a per-VM basis either using the <b
+        outputclass="bold">Shared Clipboard</b> menu item in the <b outputclass="bold">Devices</b> menu of the virtual
+      machine, or the <userinput>VBoxManage</userinput> command. </p>
+    <p>The following shared clipboard settings are available: </p>
+    <ul id="ul_onq_r24_hcc">
+      <li>
+        <p><b outputclass="bold">Disabled</b>. Disables the copy feature entirely. This is the default when creating a
+          new VM. </p>
+      </li>
+      <li>
+        <p><b outputclass="bold">Host To Guest</b>. Enables text copy operations from the host to the guest only. </p>
+      </li>
+      <li>
+        <p><b outputclass="bold">Guest To Host</b>. Enables text copy operations from the guest to the host only. </p>
+      </li>
+      <li>
+        <p><b outputclass="bold">Bidirectional</b>. Enables text copy operations in both directions: from the host to
+          the guest, and from the guest to the host. </p>
+      </li>
+      <li><b>Enable Clipboard File Transfers</b>. Allows files, in addition to text, to be copied to or from the VM.
+      </li>
+    </ul>    
     <p>To use the <userinput>VBoxManage</userinput> command to control the current clipboard mode, see <xref
         href="vboxmanage.dita#vboxmanage"/>. The <userinput>modifyvm</userinput> and <userinput>controlvm</userinput>
Index: /trunk/doc/manual/en_US/dita/topics/guestadd-dnd-formats.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/guestadd-dnd-formats.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/guestadd-dnd-formats.dita	(revision 105619)
@@ -5,23 +5,13 @@
   
   <body>
-    <p>
-        As <ph conkeyref="vbox-conkeyref-phrases/product-name"/> can run on a variety of host operating systems
-        and also supports a wide range of guests, certain data formats
-        must be translated after transfer. This is so that the
-        destination operating system, which receives the data, is able
-        to handle them in an appropriate manner.
-      </p>
+    <p>As <ph conkeyref="vbox-conkeyref-phrases/product-name"/> can run on a variety of host operating systems and also
+      supports a wide range of guests, certain data formats must be translated after transfer. This is so that the
+      destination operating system, which receives the data, is able to handle them in an appropriate manner. </p>
     <note>
-      <p>
-          When dragging files no data conversion is done in any way. For
-          example, when transferring a file from a Linux guest to a
-          Windows host the Linux-specific line endings are not converted
-          to Windows line endings.
-        </p>
+      <p>When dragging files no data conversion is done in any way. For example, when transferring a file from a Linux
+        guest to a Windows host the Linux-specific line endings are not converted to Windows line endings. </p>
     </note>
-    <p>
-        The following formats are handled by the <ph conkeyref="vbox-conkeyref-phrases/product-name"/> drag and
-        drop service:
-      </p>
+    <p>The following formats are handled by the <ph conkeyref="vbox-conkeyref-phrases/product-name"/> drag and drop
+      service: </p>
     <ul>
       <li>
Index: /trunk/doc/manual/en_US/dita/topics/guestadd-dnd-limitations.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/guestadd-dnd-limitations.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/guestadd-dnd-limitations.dita	(revision 105619)
@@ -5,22 +5,12 @@
   
   <body>
-    <p>
-        The following limitations are known for drag and drop:
-      </p>
-    <p>
-        On Windows hosts, dragging and dropping content between
-        UAC-elevated (User Account Control) programs and
-        non-UAC-elevated programs is not allowed. If you start
-        <ph conkeyref="vbox-conkeyref-phrases/product-name"/> with Administrator privileges then drag and drop
-        will not work with Windows Explorer, which runs with regular
-        user privileges by default.
-      </p>
-    <p>
-        On Linux hosts and guests, programs can query for drag and drop
-        data while the drag operation is still in progress. For example,
-        on LXDE using the PCManFM file manager. This currently is not
-        supported. As a workaround, a different file manager, such as
-        Nautilus, can be used instead.
-      </p>
+    <p>The following limitations are known for drag and drop: </p>
+    <p>On Windows hosts, dragging and dropping content between UAC-elevated (User Account Control) programs and
+      non-UAC-elevated programs is not allowed. If you start <ph conkeyref="vbox-conkeyref-phrases/product-name"/> with
+      Administrator privileges then drag and drop will not work with Windows Explorer, which runs with regular user
+      privileges by default. </p>
+    <p>On Linux hosts and guests, programs can query for drag and drop data while the drag operation is still in
+      progress. For example, on LXDE using the PCManFM file manager. This currently is not supported. As a workaround, a
+      different file manager, such as Nautilus, can be used instead. </p>
   </body>
   
Index: /trunk/doc/manual/en_US/dita/topics/guestadd-dnd.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/guestadd-dnd.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/guestadd-dnd.dita	(revision 105619)
@@ -27,5 +27,5 @@
     <p>For security reasons drag and drop can be configured at runtime on a per-VM basis either using the <b
         outputclass="bold">Drag and Drop</b> menu item in the <b outputclass="bold">Devices</b> menu of the virtual
-      machine, as shown below, or the <userinput>VBoxManage</userinput> command. </p>
+      machine, or the <userinput>VBoxManage</userinput> command. </p>
     <p>The following drag and drop modes are available: </p>
     <ul>
Index: /trunk/doc/manual/en_US/dita/topics/guestadd-gc-file-manager-using.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/guestadd-gc-file-manager-using.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/guestadd-gc-file-manager-using.dita	(revision 105619)
@@ -7,4 +7,6 @@
     <p>To use the Guest Control File Manager to transfer files, follow these steps. </p>
     <ol>
+      <li>Ensure you have the username and password for an account on the guest system, with appropriate permissions on
+        the files you need to access.</li>
       <li>
         <p>Open the Guest Control File Manager. Do either of the following: </p>
@@ -22,12 +24,11 @@
           </li>
         </ul>
-        <p>
-            The left pane shows the files on the host system.
-          </p>
+        <p>The <b>Host File System</b> pane shows the files on the host system. </p>
       </li>
       <li>
-        <p>In the Guest Control File Manager, enter authentication credentials for a user on the guest system. </p>
-        <p>Click <b outputclass="bold">Create Session</b>. </p>
-        <p>The contents of the guest VM file system appears in the right pane of the Guest Control File Manager. </p>
+        <p>In the <b>Guest File System</b> pane, enter the <b>User Name</b> and <b>Password</b> for the user you want to
+          log in as. </p>
+        <p>Click <b outputclass="bold">Open Session</b>. </p>
+        <p>The contents of the guest VM file system appears in the <b>Guest File System</b> pane. </p>
       </li>
       <li>
Index: /trunk/doc/manual/en_US/dita/topics/guestadd-gc-file-manager.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/guestadd-gc-file-manager.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/guestadd-gc-file-manager.dita	(revision 105619)
@@ -5,7 +5,7 @@
   <!-- 7.1: new icons added, pic removed-->
   <body>
-    <p>The Guest Control File Manager is a feature of the Guest Additions that enables easy copying and moving of files
-      between a guest and the host system. Other file management operations provide support to create new folders and to
-      rename or delete files. </p>
+    <p>If you have Guest Additions installed, you can use the Guest Control File Manager to copy files between a guest
+      and the host system. Other file management operations provide support to create new folders and to rename or
+      delete files. </p>
     <p>This feature is useful when the VM window of a guest is not visible. For example, when the guest is running in
       headless mode. </p>
Index: /trunk/doc/manual/en_US/dita/topics/security_clipboard.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/security_clipboard.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/security_clipboard.dita	(revision 105619)
@@ -5,16 +5,11 @@
   <!-- 7.1: Shared clipboard toggle in guest VM, bugref:10481; input from dev required -->
   <body>
-    <p>
-          The shared clipboard enables users to share data between the
-          host and the guest. Enabling the clipboard in Bidirectional
-          mode enables the guest to read and write the host clipboard.
-          The Host to Guest mode and the Guest to Host mode limit the
-          access to one direction. If the guest is able to access the
-          host clipboard it can also potentially access sensitive data
-          from the host which is shared over the clipboard.
-        </p>
-    <p> If the guest is able to read from or write to the host clipboard then a remote user
-      connecting to the guest over the network will also gain this ability, which may not be
-      appropriate. As a consequence, the shared clipboard is disabled for new machines. </p>
+    <p>The shared clipboard enables users to share data between the host and the guest. Enabling the clipboard in
+      Bidirectional mode enables the guest to read and write the host clipboard. The Host to Guest mode and the Guest to
+      Host mode limit the access to one direction. If the guest is able to access the host clipboard it can also
+      potentially access sensitive data from the host which is shared over the clipboard. </p>
+    <p>If the guest is able to read from or write to the host clipboard then a remote user connecting to the guest over
+      the network will also gain this ability, which may not be appropriate. As a consequence, the shared clipboard is
+      disabled for new machines. </p>
   </body>
   
Index: /trunk/doc/manual/en_US/dita/topics/virt-why-useful.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/virt-why-useful.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/virt-why-useful.dita	(revision 105619)
@@ -6,8 +6,6 @@
             
             <body>
-               <p>
-      The techniques and features that <ph conkeyref="vbox-conkeyref-phrases/product-name"/> provides are
-      useful in the following scenarios:
-    </p>
+               <p>The techniques and features that <ph conkeyref="vbox-conkeyref-phrases/product-name"/> provides are
+         useful in the following scenarios: </p>
                <ul>
                   <li>
Index: /trunk/doc/manual/en_US/dita/topics/virtual-media-manager.dita
===================================================================
--- /trunk/doc/manual/en_US/dita/topics/virtual-media-manager.dita	(revision 105618)
+++ /trunk/doc/manual/en_US/dita/topics/virtual-media-manager.dita	(revision 105619)
@@ -25,19 +25,13 @@
                <ul>
                   <li>
-                     <p>
-          Hard disk images, either in <ph conkeyref="vbox-conkeyref-phrases/product-name"/>'s own Virtual Disk
-          Image (VDI) format, or in the third-party formats listed in
-          <xref href="vdidetails.dita#vdidetails"/>.
-        </p>
+                     <p>Hard disk images, either in <ph conkeyref="vbox-conkeyref-phrases/product-name"/>'s own Virtual
+               Disk Image (VDI) format, or in the third-party formats listed in <xref href="vdidetails.dita#vdidetails"
+               />. </p>
                   </li>
                   <li>
-                     <p>
-          CD/DVD images in standard ISO format.
-        </p>
+                     <p>CD/DVD images in standard ISO format. </p>
                   </li>
                   <li>
-                     <p>
-          Floppy images in standard RAW format.
-        </p>
+                     <p>Floppy images in standard RAW format. </p>
                   </li>
                </ul>
@@ -96,7 +90,5 @@
           released from the VMs they are attached to and removed from the known media. </p>
                      <note>
-                        <p>
-            This option is for optical disks and floppy disks only.
-          </p>
+                        <p>This option is for optical disks and floppy disks only. </p>
                      </note>
                   </li>